/*****************************************
 *                                       *
 *  JBoss Portal: The OpenSource Portal  *
 *                                       *
 *   Distributable under LGPL license.   *
 *   See terms of license at gnu.org.    *
 *                                       *
 *****************************************/

package org.jboss.portlet.hello;

import org.jboss.portlet.JBossPortlet;
import org.jboss.portlet.JBossRenderRequest;
import org.jboss.portlet.JBossRenderResponse;
import org.jboss.portlet.PortalNode;
import org.jboss.portlet.PortalNodeURL;

import javax.portlet.PortletException;
import java.io.IOException;

public class HelloWorldPortletA extends JBossPortlet
{
   protected void doView(JBossRenderRequest req, JBossRenderResponse resp) throws IOException, PortletException
   {
      try
      {
         resp.setContentType("text/html");
         StringBuffer html = new StringBuffer();

         // link to a page
         html.append("<-- Page Linking --><br/>");
         PortalNode thisNode = req.getPortalNode().getParent(); // will return this Page as a node.
         PortalNode linkToNode = thisNode.resolve("../default");
         PortalNodeURL pageURL = resp.createRenderURL(linkToNode);
         html.append("Page: " + linkToNode.getName() + " -> ");
         html.append("<a href=\"" + pageURL.toString() + "\">" + linkToNode.getName() + "</a>");

         html.append("<br/>");

         PortalNode thisNode2 = req.getPortalNode().getParent(); // will return this Page as a node.
         PortalNode linkToNode2 = thisNode2.resolve("../IPC");
         PortalNodeURL pageURL2 = resp.createRenderURL(linkToNode2);
         html.append("Page: " + linkToNode2.getName() + " -> ");
         html.append("<a href=\"" + pageURL2.toString() + "\">" + linkToNode2.getName() + "</a>");

         html.append("<br/><br/>");

         // link to Portlet B
         html.append("<-- Portlet B Linking --><br/>");
         html.append("Enter some text, choose a color, and submit to see effects in PortletB on this page.<br/>");
         html.append("<form action=\"" + resp.createActionURL() + "\" method=\"post\">");
         html.append("<input type=\"text\" name=\"sometext\"><br/>");
         html.append("<select name=\"color\">");
         html.append("<option>blue</option>");
         html.append("<option>red</option>");
         html.append("<option>black</option>");
         html.append("</select>");
         html.append("<input type=\"submit\"/>");
         html.append("</form>");

         resp.getWriter().write(html.toString());
      }
      catch(Exception e)
      {
         e.printStackTrace();
      }
   }
}
