/*****************************************
 *                                       *
 *  JBoss Portal: The OpenSource Portal  *
 *                                       *
 *   Distributable under LGPL license.   *
 *   See terms of license at gnu.org.    *
 *                                       *
 *****************************************/

package org.jboss.portlet.hello;

import org.jboss.portlet.JBossActionRequest;
import org.jboss.portlet.JBossActionResponse;
import org.jboss.portlet.JBossPortlet;
import org.jboss.portlet.JBossRenderRequest;
import org.jboss.portlet.JBossRenderResponse;
import org.jboss.portlet.PortalNode;
import org.jboss.portlet.event.node.PortalNodeEvent;
import org.jboss.portlet.event.node.PortalNodeEventBubbler;
import org.jboss.portlet.event.node.PortalNodeEventListener;
import org.jboss.portlet.event.node.WindowActionEvent;

import javax.portlet.PortletException;
import javax.portlet.PortletSecurityException;
import java.io.IOException;
import java.io.PrintWriter;


public class HelloWorldPortletB extends JBossPortlet
{
   public void processAction(JBossActionRequest request, JBossActionResponse response) throws PortletException, PortletSecurityException, IOException
   {
      String color = request.getParameter("color");
      String text = request.getParameter("sometext");
      if(color != null && text != null)
      {
         response.setRenderParameter("color", color);
         response.setRenderParameter("sometext", text);
      }
   }

   protected void doView(JBossRenderRequest request, JBossRenderResponse response) throws PortletException, PortletSecurityException, IOException
   {
      String color = request.getParameter("color");
      String text = request.getParameter("sometext");
      response.setContentType("text/html");
      PrintWriter writer = response.getWriter();
      if(text != null)
      {
         writer.write("<div style=\"color:" + color + ";\">");
         writer.write(text);
         writer.write("</div>");
      }
      else
      {
         writer.write("Use the portlet on the left to affect behaviour in this portlet");
      }

      writer.close();
   }

   public static class Listener implements PortalNodeEventListener
   {
      public PortalNodeEvent onEvent(PortalNodeEventBubbler bubbler, PortalNodeEvent event)
      {
         PortalNode node = event.getNode();

         // Get node name
         String nodeName = node.getName();

         // See if we need to create a new event or not
         WindowActionEvent newEvent = null;
         if(nodeName.equals("HelloWorldPortletAWindow") && event instanceof WindowActionEvent)
         {
            // Find window B
            WindowActionEvent wae = (WindowActionEvent) event;
            PortalNode windowB = node.resolve("../HelloWorldPortletBWindow");
            if(windowB != null)
            {
               // We can redirect and modify the view/mode as well!
               newEvent = new WindowActionEvent(windowB);
               newEvent.setMode(wae.getMode());
               //newEvent.setWindowState(WindowState.MAXIMIZED);
               newEvent.setParameters(wae.getParameters());
            }
         }

         //
         if(newEvent != null)
         {
            // If we have a new event redirect to it
            return newEvent;
         }
         else
         {
            // Otherwise bubble up
            return bubbler.dispatch(event);
         }
      }
   }
}